<?php
namespace Planejamento\Entities;

use Geral\Util\DateTime;
use Geral\Util\DateUtil;

class Mensrequ extends Base\Mensrequ
{

    /**
     * Insere Registro
     *
     * @param String $cdfilial       Unidade
     * @param String $cdservfili     Servico
     * @param String $dtmensrequ     Data Mensagem Requisicao
     * @param String $nrsequrequ     Nrsequrequ
     * @param String $dsobsrequ      Mensagem
     * @param String $nrorg          Organizacao
     * @param String $dtinclusao     Data Inclusao
     * @param String $dtultatu       Data Ultima Atualizacao
     * @param String $nrorginclusao  Organizacao Inclusao
     * @param String $cdoperinclusao Operador Inclusao
     * @param String $cdoperultatu   Operador Ultima Atualizacao
     * @param String $nrorgultatu    Organizacao Ultima Atualizacao
     * @param String $idativo        Ativo
     *
     * @return null
     */
    public static function insereRegistro (
        $cdfilial, $cdservfili, $dtmensrequ, $nrsequrequ, $dsobsrequ,
        $nrorg, $dtinclusao, $dtultatu, $nrorginclusao, $cdoperinclusao,
        $cdoperultatu, $nrorgultatu, $idativo
    ) {
        $dt = explode(' ', $dtmensrequ);
        $reg = self::getObjectByWhere(
            "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?
             AND TO_CHAR(DTMENSREQU, 'dd/mm/YYYY') = ?",
            array($nrorg, $cdfilial, $cdservfili, $dt[0])
        );

        if (!($reg instanceof self)) {
            $reg = new self();
            $reg->setNrorg($nrorg);
            $reg->setCdfilial($cdfilial);
            $reg->setCdservfili($cdservfili);
            if (!$dtmensrequ instanceof DateTime) {
                $dtmensrequ = DateUtil::getDataDeString($dtmensrequ);
            }
            $reg->setDtmensrequ($dtmensrequ);
            $reg->setNrsequrequ($nrsequrequ);
            if (!$dtinclusao instanceof DateTime) {
                $dtinclusao = DateUtil::getDataDeString(
                    $dtinclusao, DateUtil::FORMATO_BRASILEIRO_DATAHORA
                );
            }
            $reg->setDtinclusao($dtinclusao);
            $reg->setNrorginclusao($nrorginclusao);
            $reg->setCdoperinclusao($cdoperinclusao);
        }

        $reg->setDsobsrequ($dsobsrequ);
        if (!$dtultatu instanceof DateTime) {
            $dtultatu = DateUtil::getDataDeString(
                $dtultatu, DateUtil::FORMATO_BRASILEIRO_DATAHORA
            );
        }
        $reg->setDtultatu($dtultatu);
        $reg->setCdoperultatu($cdoperultatu);
        $reg->setNrorgultatu($nrorgultatu);
        $reg->persist();
    }

}